All Classes Namespaces Functions Pages
hal::GappedSegmentIterator Class Referenceabstract

`#include <halGappedSegmentIterator.h>`

Inheritance diagram for hal::GappedSegmentIterator:

## Public Member Functions

virtual hal_size_t | getGapThreshold () const =0
virtual bool | getAtomic () const =0
virtual hal_size_t | getChildIndex () const =0
virtual hal_size_t | getNumSegments () const =0
virtual hal_size_t | getNumGaps () const =0
virtual hal_size_t | getNumGapBases () const =0
virtual hal_index_t | getLeftArrayIndex () const =0
virtual hal_index_t | getRightArrayIndex () const =0
Public Member Functions inherited from hal::SegmentIterator
virtual void | toLeft (hal_index_t leftCutoff=NULL_INDEX) const =0
virtual void | toRight (hal_index_t rightCutoff=NULL_INDEX) const =0
virtual void | toSite (hal_index_t position, bool slice=true) const =0
Public Member Functions inherited from hal::SlicedSegment
virtual void | toReverse () const =0
virtual void | toReverseInPlace () const =0
virtual hal_offset_t | getStartOffset () const =0
virtual hal_offset_t | getEndOffset () const =0
virtual void | slice (hal_offset_t startOffset=0, hal_offset_t endOffset=0) const =0
virtual bool | getReversed () const =0
Public Member Functions inherited from hal::Segment
virtual void | setArrayIndex (Genome *genome, hal_index_t arrayIndex)=0
virtual void | setArrayIndex (const Genome *genome, hal_index_t arrayIndex) const =0
virtual const Genome * | getGenome () const =0
virtual Genome * | getGenome ()=0
virtual const Sequence * | getSequence () const =0
virtual Sequence * | getSequence ()=0
virtual hal_index_t | getStartPosition () const =0
virtual hal_index_t | getEndPosition () const =0
virtual hal_size_t | getLength () const =0
virtual void | getString (std::string &outString) const =0
virtual void | setCoordinates (hal_index_t startPos, hal_size_t length)=0
virtual hal_index_t | getArrayIndex () const =0
virtual bool | leftOf (hal_index_t genomePos) const =0
virtual bool | rightOf (hal_index_t genomePos) const =0
virtual bool | overlaps (hal_index_t genomePos) const =0
virtual bool | isFirst () const =0
virtual bool | isLast () const =0
virtual bool | isMissingData (double nThreshold) const =0
virtual bool | isTop () const =0
virtual hal_size_t | getMappedSegments (std::set< MappedSegmentConstPtr > &outSegments, const Genome *tgtGenome, const std::set< const Genome * > *genomesOnPath=NULL, bool doDupes=true, hal_size_t minLength=0) const =0
virtual void | print (std::ostream &os) const =0

## Friends

class | counted_ptr< GappedSegmentIterator >
class | counted_ptr< const GappedSegmentIterator >

## Detailed Description

Interface for general gappedSegment iterator. Behaves like a regular iterator, but operates on a linear sequence of segments that are consistent modulo gaps. Is only really used internally at the moment so I haven't spent the effort to make gapped iterators fully general (such as including the Top/Bottom Segment iterfaces)

## Member Function Documentation

virtual bool hal::GappedSegmentIterator::getAtomic | ( |  | ) | const

pure virtual

When the gap iterator is in atomic mode, it allows for now gaps. Also, it will not merge consistent segments together if they are adjacent and there are no gaps (something that could happen when the threshold is set to zero but atomic is false). This is mostly a hack to get the gapped iterator to behive as a single segment

virtual hal_size_t hal::GappedSegmentIterator::getChildIndex | ( |  | ) | const

pure virtual

Gapped iterators are tied to a specific parent child pair. The child index is the index of the child genome within the parent

virtual hal_size_t hal::GappedSegmentIterator::getGapThreshold | ( |  | ) | const

pure virtual

Get the gap length threshold. This is the maximum length (in sites) of an indel such that it can be considered a gap (and therefore ignored in the rearrangement analysis

virtual hal_index_t hal::GappedSegmentIterator::getLeftArrayIndex | ( |  | ) | const

pure virtual

Get the Segment array index of the left segment of the iterator

virtual hal_size_t hal::GappedSegmentIterator::getNumGapBases | ( |  | ) | const

pure virtual

Get the number of bases within gaps within segments that have been agglomerated together within the gapped iterator

virtual hal_size_t hal::GappedSegmentIterator::getNumGaps | ( |  | ) | const

pure virtual

Get the number of gaps within segments that have been agglomerated together within the gapped iterator

virtual hal_size_t hal::GappedSegmentIterator::getNumSegments | ( |  | ) | const

pure virtual

Get the number of segments that have been agglomerated together within the gapped iterator

virtual hal_index_t hal::GappedSegmentIterator::getRightArrayIndex | ( |  | ) | const

pure virtual

Get the Segment array index of the right segment of the iterator

The documentation for this class was generated from the following file:

- inc/halGappedSegmentIterator.h